//#region 宣言
const w_IMG=700,h_IMG=1000;
const color_sel = "#f99";//ボーダー色


let timer_menu=null;
let timer_float=null;
let h_over=0;
let x_touch = 0,x_move=0;
let y_touch = 0,y_move=0;
let time_start=0,time_end=0;//getTime

const el_doc=document.documentElement;
let i_sel = 0,l_imgs=arr_jpg.length;
let image_pre = new Image();//画像先読み

let arr_pre = new Array(l_imgs + 1);
arr_pre[0] = true;
for (i = 1; i < l_imgs; i++)arr_pre[i] = false;
arr_pre[l_imgs] = true;

let str_3 = "000";
let _support = false;
let arr_lay = [];
let x_margin=0;

const str_none="";

const $ = id => document.getElementById(id);
const $log = msg => console.log(msg);


//機種判別
let i_dpr=devicePixelRatio;
let _ua = navigator.userAgent;
let _pf =navigator.platform;
let _device="";
let _browser="Chrome";//仮
if(outerHeight==0){
	_device="iOS";
	if(_ua.indexOf("CriOS")<0)_browser="Safari";
}else if(_pf=="Win32"&&innerHeight==screen.height)_device="Dev";
else if(_pf.slice(0,3)=="Win"){
	_device="Win";
	if(_ua.indexOf("Edge")>0)_browser="Edge";
	else if(_ua.indexOf("Trident")>0)_browser="IE11";
	else if(_ua.indexOf("Firefox")>0)_browser="Firefox";
	else if(_ua.indexOf("Chrome")<0)_browser="";
}
else if(_ua.indexOf('Android')>0)_device="Android";
else if(_pf=="MacPPC")_device="Mac";
if(_device=="")_device="unknown";

let bool_land=false;//横持ちかどうか
let w_land=0,w_port=0;//width
let w_view=0,h_view=0;//表示範囲
let w_area=0,h_area=0;//タップ範囲
let zoom_land=0,zoom_port;//zoom_min

if(_device=="Dev")window.addEventListener("resize",ResizeDev);
else if(_device=="Android")window.addEventListener("resize",ResizeAndroid);

window.addEventListener("orientationchange", OrientationChange);
document.addEventListener("keydown", KeyDown);


/** @type {Array.<HTMLImageElement>} */ let arr_img;

/** @type {HTMLImageElement} */let IMG;
/** @type {HTMLImageElement} */let IMG1;
/** @type {HTMLImageElement} */let img_bar;

/** @type {HTMLDivElement} */let div_img;
/** @type {HTMLDivElement} */let div_ui;
/** @type {HTMLDivElement} */let div_list;
/** @type {HTMLParagraphElement} */let p_page;
/** @type {HTMLParagraphElement} */let p_msg;
/** @type {HTMLParagraphElement} */let p_float;
/** @type {HTMLInputElement} */let input_tel;

//#endregion 宣言

window.addEventListener(_device == "iOS" ? "pagehide" : "beforeunload", $$UnLoad);
function $$UnLoad() {
	sessionStorage.setItem('i_sel', i_sel);
}


document.addEventListener("DOMContentLoaded",DOMContentLoaded);
function DOMContentLoaded(){
	//#region getID =$("");
	IMG=$("IMG");
	IMG1 = $("IMG1");
	img_bar=$("img_bar");
	div_list=$("div_list");
	div_img=$("div_img");
	div_ui=$("div_ui");
	p_page=$("p_page");
	p_msg=$("p_msg");
	p_float=$("p_float");//
	input_tel = $("input_tel");

	//#endregion


	if(_device=="iOS"){
		div_img.addEventListener("touchstart",Touchstart,{passive:false});
		div_img.addEventListener("touchend",Touchend,{passive:false});
		div_img.addEventListener("touchmove",Touchmove,{passive:false});
	}else{
		div_img.addEventListener("touchstart",Touchstart,false);
		div_img.addEventListener("touchend",Touchend,false);
		div_img.addEventListener("touchmove",Touchmove,false);
	}

	document.body.addEventListener("touchstart", TouchstartBody);
	img_bar.addEventListener("touchstart",TouchBar);
	p_page.addEventListener("touchstart",()=>{scrollTo(0, 0);});

	let htm="";
	for (let i = 0; i < l_imgs; i++)
		htm += "<img src='s/" + arr_jpg[i] + ".jpg' alt=" + i + ">";
	div_list.insertAdjacentHTML('beforeend',htm);
	arr_img=div_list.children;
	div_list.addEventListener("click",ClkDivList);



	let key = sessionStorage.getItem('i_sel');
	if (key) i_sel = key * 1;
	SelIMG(i_sel);
	CalcZoom();
	if(w_port==414)return;

	l = arr_png.length;
	let t = ""; let k = 0; let j = 0;
	for (i = 0; i < l; i++) {
		t = arr_png[i];
		if (t.length < 4) {
			k = t * 1 - 1;
			arr_lay[k] = htm;
		} else {
			j = t.indexOf("_");
			k = t.slice(0, j) * 1 - 1;
			arr_lay[k] = htm = t;
		}
	}

	let d = new Date();
	let m = d.getMonth() + 1;
	let y = d.getFullYear() - 2000;
	t = (y - m) << (8 + y % 8 + m);
	str_3 = t.toString().slice(-4, -1);

	let tel = localStorage.getItem("tel");
	if (tel != null) {
		if (tel == str_3) {
			$Support();
			input_tel.value = tel;
		}
		else {
			localStorage.removeItem("tel");
			i_code.innerText = "今月のコードを入力して下さい";
		}
	}
	input_tel.addEventListener('input', $Chk_tel);
	if (_device == "Android") {
		input_tel.addEventListener('focus', function () { div_ui.style.visibility = "hidden" });
		input_tel.addEventListener('blur', function () { div_ui.style.visibility = "" });
	}
}

//#region IMGev

/** @param {TouchEvent} event */
function TouchstartBody(event) {
	let et = event.touches;
	if (et.length > 1) {
		if (_device == "iOS") event.preventDefault();
		return;
	}
	
	if(event.srcElement.tagName=="BODY"){
		if(et[0].clientX<200)SelIMG(i_sel - 1);
		else SelIMG(i_sel + 1);
	}
}

/** @param {TouchEvent} event */
function Touchstart(event){
	let et=event.touches;
	if(et.length>1){
		if(_device=="iOS")event.preventDefault();
		return;
	}
	x_touch =x_move = et[0].clientX;
	y_touch =y_move = et[0].clientY;
	//y_move=y_touch;
	time_start = new Date().getTime();
	event.stopPropagation();
	return false;
}

/** @param {TouchEvent} event */
function Touchmove(event){
	if(!bool_land)return;

	let y=event.changedTouches[0].clientY;

	let down=0;
	if(y_move < y)down=1;
	if(y_move > y)down=-1;
	y_move = y;
	y=div_img.scrollTop;
	//event.cancelBubble=true;
	if(h_over<0)return;
	if(event.cancelable && 
		(down==1&&y==0||down==-1&&y>h_over&&h_over>0)
	){
		event.preventDefault();
		return false;
	}
}


/** @param {TouchEvent} event */
function Touchend(event){
	let time =new Date().getTime();
	time_end=time;
	time = time_end-time_start;

	if(time>400){
		if(event.cancelable)event.preventDefault();
		return;
	}

	let et=event.changedTouches[0];
	let y = et.clientY - y_touch;
	let _y = y; if(_y<0)_y=-_y;
	let x = et.clientX - x_touch;
	let _x = x; if(_x<0)_x=-_x;
	let vsb=div_ui.style.visibility=="";
	let w=w_area;
	if(bool_land&&!vsb)w*=2;

	if(time<200&&_x<3&&_y<3){//タップ
		if(x_touch<w)SelIMG(i_sel-1);
		else if(x_touch>w_view-w)SelIMG(i_sel+1);

		if(bool_land){
			y=scrollY;
			_y=arr_img[i_sel].offsetTop;
			if(_y<y||_y>y+300){
				arr_img[i_sel].scrollIntoView(1);
				if(_y>20)scrollBy(0, -20);
			}
			//p_float.textContent="y:"+y+"; _y:"+_y+"; inh:"+innerHeight;
		}
		if(event.cancelable)event.preventDefault();
	}//タップ

}
//#endregion IMGev

//#region evFunc

/** @param {TouchEvent} event */
function TouchBar(event) {
	let pt = (et=event.touches[0].clientX-div_ui.offsetLeft) * 100 / div_ui.offsetWidth | 0;

	if (pt < 20) SelIMG(i_sel - 1);//prev
	else if (pt < 50) SelIMG(i_sel + 1);//next
	else if (pt > 70){//index
		event.preventDefault();
		JumpIndex(0);
	}
}

/** @param {MouseEvent} event */
function ClkDivList(event) {
	let el=event.srcElement;
	if(el.tagName!="IMG")return;
	SelIMG(el.alt * 1);

	if(bool_land){
		div_img.scrollTo(0,0);
		Pfloat(p_page.textContent);
	}
	else window.scrollTo(0, 0);
}




function OrientationChange(event){
	bool_land=!bool_land;
	if(_device!="Dev"&&bool_land){
		let w=div_img.offsetWidth;
		let h=(w*25/18)|0;
		h_over=h-innerHeight+3;
		w_view=w;
		w_area=w/5;
	}
	
}

function ResizeDev(event){//"Dev"
	i_dpr=devicePixelRatio;
	CalcZoom();
}

function ResizeAndroid(event){//Android
	if(!bool_land)return;
	let h=IMG.height;
	h_over=h-innerHeight+3;
}



function KeyDown(event){
	let k=event.keyCode;
	let shift=event.shiftKey;
	if (k == 32 || k > 36 && k < 41){
		window.scrollTo(0, 0);
		event.preventDefault();
	} 

	switch(k){
		case 13:JumpIndex(0);break;//Enter

		case 37:SelIMG(i_sel-1);break;//left

		case 38://Up
			if(bool_land)div_img.scrollTo(0, 0);
			else window.scrollTo(0, 0); break;

		case 39:SelIMG(i_sel+1);break;//right

		case 40://Down
			if(bool_land)div_img.scrollTo(0, h_over);
			else JumpIndex(0);
			break;

		default:break;
	}
}





//#endregion evFunc

//#region function

function CalcZoom(){//load or ResizeDev zoom_min算出

	let w=innerWidth,h=innerHeight;
	bool_land=w>h;
	if(_device!="Win"){
		w=screen.width;
		h=screen.height;
	}

	w_land=w>h?w:h;
	w_port=w>h?h:w;
	w=div_img.offsetWidth;
	let imh=(w*25/18)|0;
	h=innerHeight;
	h_over=imh-h+3;
	w_view=w;
	w_area=w/5;

	//p_float.textContent="calc Hov:"+h_over+", inH:"+h+", ImH:"+imh;
}



function JumpIndex(i) {
	if (bool_land){
		div_ui.style.visibility="hidden";
		arr_img[i_sel].scrollIntoView(1);
	}else{//port
		arr_img[i_sel].scrollIntoView(i);
		if (i == 0) window.scrollBy(0, 100);
		else window.scrollBy(0, -50);
	} 
}

function SelIMG(i){
	if(i<0)i=l_imgs-1;
	else if(i>l_imgs-1)i=0;
	if (!arr_pre[i])IMG.src = "s/" + arr_jpg[i] + ".jpg";
	IMG.src = "m/" + arr_jpg[i] + ".jpg";
	arr_pre[i]=true;
	if (!arr_pre[i+1]) image_pre.src = "m/" + arr_jpg[i + 1] + ".jpg";
	arr_pre[i+1] = true;
	arr_img[i_sel].style.borderColor = "";
	i_sel = i;
	arr_img[i_sel].style.borderColor = color_sel;

	var str = "";
	if (l_imgs < 100) str ="Page."+ ("00" + (i_sel+1)).slice(-2);	
	else str ="Pg."+("000" + (i_sel + 1)).slice(-3);
	str+="/" + l_imgs;
	p_page.textContent = str ;
	$OverLay();
}

function Pfloat(str){
	p_float.textContent=str;
	clearTimeout(timer_float);
	timer_float=setTimeout("p_float.textContent=str_none",1200);
}

function $OverLay() {
	if (!_support) return;
	if (!bool_land && arr_lay[i_sel]) {
		IMG1.src = _url + "_/" + arr_lay[i_sel] + ".png";
		let t = arr_lay[i_sel].split("_");
		let x = t[1] * 10;
		let y = t[2] * 10;
		
		IMG1.style.left = x + "px";
		IMG1.style.top = y + "px";
		
	} else IMG1.src = "0.png";
}

function $Support() {
	if (_support) return;
	if (w_port == 414) return;
	_support = true;
	i_code.innerText = "支援者向け特典 " + arr_png.length + "枚のCGを上書きしました";
	for (let i = 0; i < l_imgs; i++)if (arr_lay[i])
		arr_img[i].style.borderRadius = "20px";
}


function $Chk_tel(event) {
	let t = input_tel.value;
	if (_support && t == "") {

		_support = false;
		i_code.innerText = "特典モードを解除しました";
		for (let i = 0; i < l_imgs; i++)if (arr_lay[i])
			arr_img[i].style.borderRadius = "";
		localStorage.removeItem("tel");
	}

	if (t.length != 3) return;

	if (!_support && t == str_3) {

		localStorage.setItem("tel", t);
		$Support();
	}

}

//#endregion